/* Converted to D from jni.h by htod */
module jni;
/*
 * @(#)jni.h	1.56 03/12/19
 *
 * Copyright 2004 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * We used part of Netscape's Java Runtime Interface (JRI) as the starting
 * point of our design and implementation.
 */

/******************************************************************************
 * Java Runtime Interface
 * Copyright (c) 1996 Netscape Communications Corporation. All rights reserved.
 *****************************************************************************/

//C     #ifndef _JAVASOFT_JNI_H_
//C     #define _JAVASOFT_JNI_H_

//C     #include <stdio.h>
import std.c.stdio;
//C     #include <stdarg.h>
import std.c.stdarg;

/* jni_md.h contains the machine-dependent typedefs for jbyte, jint
   and jlong */

//C     #include "jni_md.h"
import jni_md;

//C     #ifdef __cplusplus
//C     extern "C" {
//C     #endif

/*
 * JNI Types
 */

//C     #ifndef JNI_TYPES_ALREADY_DEFINED_IN_JNI_MD_H

//C     typedef unsigned char	jboolean;
extern (C):
alias ubyte jboolean;
//C     typedef unsigned short	jchar;
alias ushort jchar;
//C     typedef short		jshort;
alias short jshort;
//C     typedef float		jfloat;
alias float jfloat;
//C     typedef double		jdouble;
alias double jdouble;

//C     typedef jint            jsize;
alias jint jsize;

//C     #ifdef __cplusplus

//C     class _jobject {};
//C     class _jclass : public _jobject {};
//C     class _jthrowable : public _jobject {};
//C     class _jstring : public _jobject {};
//C     class _jarray : public _jobject {};
//C     class _jbooleanArray : public _jarray {};
//C     class _jbyteArray : public _jarray {};
//C     class _jcharArray : public _jarray {};
//C     class _jshortArray : public _jarray {};
//C     class _jintArray : public _jarray {};
//C     class _jlongArray : public _jarray {};
//C     class _jfloatArray : public _jarray {};
//C     class _jdoubleArray : public _jarray {};
//C     class _jobjectArray : public _jarray {};

//C     typedef _jobject *jobject;
//C     typedef _jclass *jclass;
//C     typedef _jthrowable *jthrowable;
//C     typedef _jstring *jstring;
//C     typedef _jarray *jarray;
//C     typedef _jbooleanArray *jbooleanArray;
//C     typedef _jbyteArray *jbyteArray;
//C     typedef _jcharArray *jcharArray;
//C     typedef _jshortArray *jshortArray;
//C     typedef _jintArray *jintArray;
//C     typedef _jlongArray *jlongArray;
//C     typedef _jfloatArray *jfloatArray;
//C     typedef _jdoubleArray *jdoubleArray;
//C     typedef _jobjectArray *jobjectArray;

//C     #else

//C     struct _jobject;

//C     typedef struct _jobject *jobject;
alias void* _jobject;
alias _jobject *jobject;
//C     typedef jobject jclass;
alias jobject jclass;
//C     typedef jobject jthrowable;
alias jobject jthrowable;
//C     typedef jobject jstring;
alias jobject jstring;
//C     typedef jobject jarray;
alias jobject jarray;
//C     typedef jarray jbooleanArray;
alias jarray jbooleanArray;
//C     typedef jarray jbyteArray;
alias jarray jbyteArray;
//C     typedef jarray jcharArray;
alias jarray jcharArray;
//C     typedef jarray jshortArray;
alias jarray jshortArray;
//C     typedef jarray jintArray;
alias jarray jintArray;
//C     typedef jarray jlongArray;
alias jarray jlongArray;
//C     typedef jarray jfloatArray;
alias jarray jfloatArray;
//C     typedef jarray jdoubleArray;
alias jarray jdoubleArray;
//C     typedef jarray jobjectArray;
alias jarray jobjectArray;

//C     #endif

//C     typedef jobject jweak;
alias jobject jweak;

//C     typedef union jvalue {
//C         jboolean z;
//C         jbyte    b;
//C         jchar    c;
//C         jshort   s;
//C         jint     i;
//C         jlong    j;
//C         jfloat   f;
//C         jdouble  d;
//C         jobject  l;
//C     } jvalue;
union jvalue
{
    jboolean z;
    jbyte b;
    jchar c;
    jshort s;
    jint i;
    jlong j;
    jfloat f;
    jdouble d;
    jobject l;
}

//C     struct _jfieldID;
//C     typedef struct _jfieldID *jfieldID;
alias void* _jfieldID;
alias _jfieldID *jfieldID;

//C     struct _jmethodID;
//C     typedef struct _jmethodID *jmethodID;
alias void* _jmethodID;
alias _jmethodID *jmethodID;

//C     #endif /* JNI_TYPES_ALREADY_DEFINED_IN_JNI_MD_H */

/*
 * jboolean constants
 */

//C     #define JNI_FALSE 0
//C     #define JNI_TRUE 1
const JNI_FALSE = 0;

const JNI_TRUE = 1;
/*
 * possible return values for JNI functions.
 */

//C     #define JNI_OK           0                 /* success */
//C     #define JNI_ERR          (-1)              /* unknown error */
const JNI_OK = 0;
//C     #define JNI_EDETACHED    (-2)              /* thread detached from the VM */
//C     #define JNI_EVERSION     (-3)              /* JNI version error */
//C     #define JNI_ENOMEM       (-4)              /* not enough memory */
//C     #define JNI_EEXIST       (-5)              /* VM already created */
//C     #define JNI_EINVAL       (-6)              /* invalid arguments */

/*
 * used in ReleaseScalarArrayElements
 */

//C     #define JNI_COMMIT 1
//C     #define JNI_ABORT 2
const JNI_COMMIT = 1;

const JNI_ABORT = 2;
/*
 * used in RegisterNatives to describe native method name, signature,
 * and function pointer.
 */

//C     typedef struct {
//C         char *name;
//C         char *signature;
//C         void *fnPtr;
//C     } JNINativeMethod;
struct _N1
{
    char *name;
    char *signature;
    void *fnPtr;
}
alias _N1 JNINativeMethod;

/*
 * JNI Native Method Interface.
 */

//C     struct JNINativeInterface_;

//C     struct JNIEnv_;

//C     #ifdef __cplusplus
//C     typedef JNIEnv_ JNIEnv;
//C     #else
//C     typedef const struct JNINativeInterface_ *JNIEnv;
alias JNINativeInterface_ *JNIEnv;
//C     #endif

/*
 * JNI Invocation Interface.
 */

//C     struct JNIInvokeInterface_;

//C     struct JavaVM_;

//C     #ifdef __cplusplus
//C     typedef JavaVM_ JavaVM;
//C     #else
//C     typedef const struct JNIInvokeInterface_ *JavaVM;
alias JNIInvokeInterface_ *JavaVM;
//C     #endif

//C     struct JNINativeInterface_ {
//C         void *reserved0;
//C         void *reserved1;
//C         void *reserved2;

//C         void *reserved3;
//C         jint (JNICALL *GetVersion)(JNIEnv *env);

//C         jclass (JNICALL *DefineClass)
//C           (JNIEnv *env, const char *name, jobject loader, const jbyte *buf,
//C            jsize len);
//C         jclass (JNICALL *FindClass)
//C           (JNIEnv *env, const char *name);

//C         jmethodID (JNICALL *FromReflectedMethod)
//C           (JNIEnv *env, jobject method);
//C         jfieldID (JNICALL *FromReflectedField)
//C           (JNIEnv *env, jobject field);

//C         jobject (JNICALL *ToReflectedMethod)
//C           (JNIEnv *env, jclass cls, jmethodID methodID, jboolean isStatic);

//C         jclass (JNICALL *GetSuperclass)
//C           (JNIEnv *env, jclass sub);
//C         jboolean (JNICALL *IsAssignableFrom)
//C           (JNIEnv *env, jclass sub, jclass sup);

//C         jobject (JNICALL *ToReflectedField)
//C           (JNIEnv *env, jclass cls, jfieldID fieldID, jboolean isStatic);

//C         jint (JNICALL *Throw)
//C           (JNIEnv *env, jthrowable obj);
//C         jint (JNICALL *ThrowNew)
//C           (JNIEnv *env, jclass clazz, const char *msg);
//C         jthrowable (JNICALL *ExceptionOccurred)
//C           (JNIEnv *env);
//C         void (JNICALL *ExceptionDescribe)
//C           (JNIEnv *env);
//C         void (JNICALL *ExceptionClear)
//C           (JNIEnv *env);
//C         void (JNICALL *FatalError)
//C           (JNIEnv *env, const char *msg);

//C         jint (JNICALL *PushLocalFrame)
//C           (JNIEnv *env, jint capacity);
//C         jobject (JNICALL *PopLocalFrame)
//C           (JNIEnv *env, jobject result);

//C         jobject (JNICALL *NewGlobalRef)
//C           (JNIEnv *env, jobject lobj);
//C         void (JNICALL *DeleteGlobalRef)
//C           (JNIEnv *env, jobject gref);
//C         void (JNICALL *DeleteLocalRef)
//C           (JNIEnv *env, jobject obj);
//C         jboolean (JNICALL *IsSameObject)
//C           (JNIEnv *env, jobject obj1, jobject obj2);
//C         jobject (JNICALL *NewLocalRef)
//C           (JNIEnv *env, jobject ref);
//C         jint (JNICALL *EnsureLocalCapacity)
//C           (JNIEnv *env, jint capacity);

//C         jobject (JNICALL *AllocObject)
//C           (JNIEnv *env, jclass clazz);
//C         jobject (JNICALL *NewObject)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jobject (JNICALL *NewObjectV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jobject (JNICALL *NewObjectA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jclass (JNICALL *GetObjectClass)
//C           (JNIEnv *env, jobject obj);
//C         jboolean (JNICALL *IsInstanceOf)
//C           (JNIEnv *env, jobject obj, jclass clazz);

//C         jmethodID (JNICALL *GetMethodID)
//C           (JNIEnv *env, jclass clazz, const char *name, const char *sig);

//C         jobject (JNICALL *CallObjectMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jobject (JNICALL *CallObjectMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jobject (JNICALL *CallObjectMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue * args);

//C         jboolean (JNICALL *CallBooleanMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jboolean (JNICALL *CallBooleanMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jboolean (JNICALL *CallBooleanMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue * args);

//C         jbyte (JNICALL *CallByteMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jbyte (JNICALL *CallByteMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jbyte (JNICALL *CallByteMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         jchar (JNICALL *CallCharMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jchar (JNICALL *CallCharMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jchar (JNICALL *CallCharMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         jshort (JNICALL *CallShortMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jshort (JNICALL *CallShortMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jshort (JNICALL *CallShortMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         jint (JNICALL *CallIntMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jint (JNICALL *CallIntMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jint (JNICALL *CallIntMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         jlong (JNICALL *CallLongMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jlong (JNICALL *CallLongMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jlong (JNICALL *CallLongMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         jfloat (JNICALL *CallFloatMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jfloat (JNICALL *CallFloatMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jfloat (JNICALL *CallFloatMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         jdouble (JNICALL *CallDoubleMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         jdouble (JNICALL *CallDoubleMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         jdouble (JNICALL *CallDoubleMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args);

//C         void (JNICALL *CallVoidMethod)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, ...);
//C         void (JNICALL *CallVoidMethodV)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, va_list args);
//C         void (JNICALL *CallVoidMethodA)
//C           (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue * args);

//C         jobject (JNICALL *CallNonvirtualObjectMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jobject (JNICALL *CallNonvirtualObjectMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jobject (JNICALL *CallNonvirtualObjectMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue * args);

//C         jboolean (JNICALL *CallNonvirtualBooleanMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jboolean (JNICALL *CallNonvirtualBooleanMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jboolean (JNICALL *CallNonvirtualBooleanMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue * args);

//C         jbyte (JNICALL *CallNonvirtualByteMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jbyte (JNICALL *CallNonvirtualByteMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jbyte (JNICALL *CallNonvirtualByteMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         jchar (JNICALL *CallNonvirtualCharMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jchar (JNICALL *CallNonvirtualCharMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jchar (JNICALL *CallNonvirtualCharMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         jshort (JNICALL *CallNonvirtualShortMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jshort (JNICALL *CallNonvirtualShortMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jshort (JNICALL *CallNonvirtualShortMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         jint (JNICALL *CallNonvirtualIntMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jint (JNICALL *CallNonvirtualIntMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jint (JNICALL *CallNonvirtualIntMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         jlong (JNICALL *CallNonvirtualLongMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jlong (JNICALL *CallNonvirtualLongMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jlong (JNICALL *CallNonvirtualLongMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         jfloat (JNICALL *CallNonvirtualFloatMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jfloat (JNICALL *CallNonvirtualFloatMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jfloat (JNICALL *CallNonvirtualFloatMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         jdouble (JNICALL *CallNonvirtualDoubleMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         jdouble (JNICALL *CallNonvirtualDoubleMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         jdouble (JNICALL *CallNonvirtualDoubleMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue *args);

//C         void (JNICALL *CallNonvirtualVoidMethod)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...);
//C         void (JNICALL *CallNonvirtualVoidMethodV)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            va_list args);
//C         void (JNICALL *CallNonvirtualVoidMethodA)
//C           (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,
//C            const jvalue * args);

//C         jfieldID (JNICALL *GetFieldID)
//C           (JNIEnv *env, jclass clazz, const char *name, const char *sig);

//C         jobject (JNICALL *GetObjectField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jboolean (JNICALL *GetBooleanField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jbyte (JNICALL *GetByteField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jchar (JNICALL *GetCharField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jshort (JNICALL *GetShortField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jint (JNICALL *GetIntField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jlong (JNICALL *GetLongField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jfloat (JNICALL *GetFloatField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);
//C         jdouble (JNICALL *GetDoubleField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID);

//C         void (JNICALL *SetObjectField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jobject val);
//C         void (JNICALL *SetBooleanField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jboolean val);
//C         void (JNICALL *SetByteField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jbyte val);
//C         void (JNICALL *SetCharField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jchar val);
//C         void (JNICALL *SetShortField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jshort val);
//C         void (JNICALL *SetIntField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jint val);
//C         void (JNICALL *SetLongField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jlong val);
//C         void (JNICALL *SetFloatField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jfloat val);
//C         void (JNICALL *SetDoubleField)
//C           (JNIEnv *env, jobject obj, jfieldID fieldID, jdouble val);

//C         jmethodID (JNICALL *GetStaticMethodID)
//C           (JNIEnv *env, jclass clazz, const char *name, const char *sig);

//C         jobject (JNICALL *CallStaticObjectMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jobject (JNICALL *CallStaticObjectMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jobject (JNICALL *CallStaticObjectMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jboolean (JNICALL *CallStaticBooleanMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jboolean (JNICALL *CallStaticBooleanMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jboolean (JNICALL *CallStaticBooleanMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jbyte (JNICALL *CallStaticByteMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jbyte (JNICALL *CallStaticByteMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jbyte (JNICALL *CallStaticByteMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jchar (JNICALL *CallStaticCharMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jchar (JNICALL *CallStaticCharMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jchar (JNICALL *CallStaticCharMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jshort (JNICALL *CallStaticShortMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jshort (JNICALL *CallStaticShortMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jshort (JNICALL *CallStaticShortMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jint (JNICALL *CallStaticIntMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jint (JNICALL *CallStaticIntMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jint (JNICALL *CallStaticIntMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jlong (JNICALL *CallStaticLongMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jlong (JNICALL *CallStaticLongMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jlong (JNICALL *CallStaticLongMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jfloat (JNICALL *CallStaticFloatMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jfloat (JNICALL *CallStaticFloatMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jfloat (JNICALL *CallStaticFloatMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         jdouble (JNICALL *CallStaticDoubleMethod)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, ...);
//C         jdouble (JNICALL *CallStaticDoubleMethodV)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args);
//C         jdouble (JNICALL *CallStaticDoubleMethodA)
//C           (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args);

//C         void (JNICALL *CallStaticVoidMethod)
//C           (JNIEnv *env, jclass cls, jmethodID methodID, ...);
//C         void (JNICALL *CallStaticVoidMethodV)
//C           (JNIEnv *env, jclass cls, jmethodID methodID, va_list args);
//C         void (JNICALL *CallStaticVoidMethodA)
//C           (JNIEnv *env, jclass cls, jmethodID methodID, const jvalue * args);

//C         jfieldID (JNICALL *GetStaticFieldID)
//C           (JNIEnv *env, jclass clazz, const char *name, const char *sig);
//C         jobject (JNICALL *GetStaticObjectField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jboolean (JNICALL *GetStaticBooleanField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jbyte (JNICALL *GetStaticByteField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jchar (JNICALL *GetStaticCharField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jshort (JNICALL *GetStaticShortField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jint (JNICALL *GetStaticIntField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jlong (JNICALL *GetStaticLongField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jfloat (JNICALL *GetStaticFloatField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);
//C         jdouble (JNICALL *GetStaticDoubleField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID);

//C         void (JNICALL *SetStaticObjectField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jobject value);
//C         void (JNICALL *SetStaticBooleanField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jboolean value);
//C         void (JNICALL *SetStaticByteField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jbyte value);
//C         void (JNICALL *SetStaticCharField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jchar value);
//C         void (JNICALL *SetStaticShortField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jshort value);
//C         void (JNICALL *SetStaticIntField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jint value);
//C         void (JNICALL *SetStaticLongField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jlong value);
//C         void (JNICALL *SetStaticFloatField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jfloat value);
//C         void (JNICALL *SetStaticDoubleField)
//C           (JNIEnv *env, jclass clazz, jfieldID fieldID, jdouble value);

//C         jstring (JNICALL *NewString)
//C           (JNIEnv *env, const jchar *unicode, jsize len);
//C         jsize (JNICALL *GetStringLength)
//C           (JNIEnv *env, jstring str);
//C         const jchar *(JNICALL *GetStringChars)
//C           (JNIEnv *env, jstring str, jboolean *isCopy);
//C         void (JNICALL *ReleaseStringChars)
//C           (JNIEnv *env, jstring str, const jchar *chars);

//C         jstring (JNICALL *NewStringUTF)
//C           (JNIEnv *env, const char *utf);
//C         jsize (JNICALL *GetStringUTFLength)
//C           (JNIEnv *env, jstring str);
//C         const char* (JNICALL *GetStringUTFChars)
//C           (JNIEnv *env, jstring str, jboolean *isCopy);
//C         void (JNICALL *ReleaseStringUTFChars)
//C           (JNIEnv *env, jstring str, const char* chars);


//C         jsize (JNICALL *GetArrayLength)
//C           (JNIEnv *env, jarray array);

//C         jobjectArray (JNICALL *NewObjectArray)
//C           (JNIEnv *env, jsize len, jclass clazz, jobject init);
//C         jobject (JNICALL *GetObjectArrayElement)
//C           (JNIEnv *env, jobjectArray array, jsize index);
//C         void (JNICALL *SetObjectArrayElement)
//C           (JNIEnv *env, jobjectArray array, jsize index, jobject val);

//C         jbooleanArray (JNICALL *NewBooleanArray)
//C           (JNIEnv *env, jsize len);
//C         jbyteArray (JNICALL *NewByteArray)
//C           (JNIEnv *env, jsize len);
//C         jcharArray (JNICALL *NewCharArray)
//C           (JNIEnv *env, jsize len);
//C         jshortArray (JNICALL *NewShortArray)
//C           (JNIEnv *env, jsize len);
//C         jintArray (JNICALL *NewIntArray)
//C           (JNIEnv *env, jsize len);
//C         jlongArray (JNICALL *NewLongArray)
//C           (JNIEnv *env, jsize len);
//C         jfloatArray (JNICALL *NewFloatArray)
//C           (JNIEnv *env, jsize len);
//C         jdoubleArray (JNICALL *NewDoubleArray)
//C           (JNIEnv *env, jsize len);

//C         jboolean * (JNICALL *GetBooleanArrayElements)
//C           (JNIEnv *env, jbooleanArray array, jboolean *isCopy);
//C         jbyte * (JNICALL *GetByteArrayElements)
//C           (JNIEnv *env, jbyteArray array, jboolean *isCopy);
//C         jchar * (JNICALL *GetCharArrayElements)
//C           (JNIEnv *env, jcharArray array, jboolean *isCopy);
//C         jshort * (JNICALL *GetShortArrayElements)
//C           (JNIEnv *env, jshortArray array, jboolean *isCopy);
//C         jint * (JNICALL *GetIntArrayElements)
//C           (JNIEnv *env, jintArray array, jboolean *isCopy);
//C         jlong * (JNICALL *GetLongArrayElements)
//C           (JNIEnv *env, jlongArray array, jboolean *isCopy);
//C         jfloat * (JNICALL *GetFloatArrayElements)
//C           (JNIEnv *env, jfloatArray array, jboolean *isCopy);
//C         jdouble * (JNICALL *GetDoubleArrayElements)
//C           (JNIEnv *env, jdoubleArray array, jboolean *isCopy);

//C         void (JNICALL *ReleaseBooleanArrayElements)
//C           (JNIEnv *env, jbooleanArray array, jboolean *elems, jint mode);
//C         void (JNICALL *ReleaseByteArrayElements)
//C           (JNIEnv *env, jbyteArray array, jbyte *elems, jint mode);
//C         void (JNICALL *ReleaseCharArrayElements)
//C           (JNIEnv *env, jcharArray array, jchar *elems, jint mode);
//C         void (JNICALL *ReleaseShortArrayElements)
//C           (JNIEnv *env, jshortArray array, jshort *elems, jint mode);
//C         void (JNICALL *ReleaseIntArrayElements)
//C           (JNIEnv *env, jintArray array, jint *elems, jint mode);
//C         void (JNICALL *ReleaseLongArrayElements)
//C           (JNIEnv *env, jlongArray array, jlong *elems, jint mode);
//C         void (JNICALL *ReleaseFloatArrayElements)
//C           (JNIEnv *env, jfloatArray array, jfloat *elems, jint mode);
//C         void (JNICALL *ReleaseDoubleArrayElements)
//C           (JNIEnv *env, jdoubleArray array, jdouble *elems, jint mode);

//C         void (JNICALL *GetBooleanArrayRegion)
//C           (JNIEnv *env, jbooleanArray array, jsize start, jsize l, jboolean *buf);
//C         void (JNICALL *GetByteArrayRegion)
//C           (JNIEnv *env, jbyteArray array, jsize start, jsize len, jbyte *buf);
//C         void (JNICALL *GetCharArrayRegion)
//C           (JNIEnv *env, jcharArray array, jsize start, jsize len, jchar *buf);
//C         void (JNICALL *GetShortArrayRegion)
//C           (JNIEnv *env, jshortArray array, jsize start, jsize len, jshort *buf);
//C         void (JNICALL *GetIntArrayRegion)
//C           (JNIEnv *env, jintArray array, jsize start, jsize len, jint *buf);
//C         void (JNICALL *GetLongArrayRegion)
//C           (JNIEnv *env, jlongArray array, jsize start, jsize len, jlong *buf);
//C         void (JNICALL *GetFloatArrayRegion)
//C           (JNIEnv *env, jfloatArray array, jsize start, jsize len, jfloat *buf);
//C         void (JNICALL *GetDoubleArrayRegion)
//C           (JNIEnv *env, jdoubleArray array, jsize start, jsize len, jdouble *buf);

//C         void (JNICALL *SetBooleanArrayRegion)
//C           (JNIEnv *env, jbooleanArray array, jsize start, jsize l, const jboolean *buf);
//C         void (JNICALL *SetByteArrayRegion)
//C           (JNIEnv *env, jbyteArray array, jsize start, jsize len, const jbyte *buf);
//C         void (JNICALL *SetCharArrayRegion)
//C           (JNIEnv *env, jcharArray array, jsize start, jsize len, const jchar *buf);
//C         void (JNICALL *SetShortArrayRegion)
//C           (JNIEnv *env, jshortArray array, jsize start, jsize len, const jshort *buf);
//C         void (JNICALL *SetIntArrayRegion)
//C           (JNIEnv *env, jintArray array, jsize start, jsize len, const jint *buf);
//C         void (JNICALL *SetLongArrayRegion)
//C           (JNIEnv *env, jlongArray array, jsize start, jsize len, const jlong *buf);
//C         void (JNICALL *SetFloatArrayRegion)
//C           (JNIEnv *env, jfloatArray array, jsize start, jsize len, const jfloat *buf);
//C         void (JNICALL *SetDoubleArrayRegion)
//C           (JNIEnv *env, jdoubleArray array, jsize start, jsize len, const jdouble *buf);

//C         jint (JNICALL *RegisterNatives)
//C           (JNIEnv *env, jclass clazz, const JNINativeMethod *methods,
//C            jint nMethods);
//C         jint (JNICALL *UnregisterNatives)
//C           (JNIEnv *env, jclass clazz);

//C         jint (JNICALL *MonitorEnter)
//C           (JNIEnv *env, jobject obj);
//C         jint (JNICALL *MonitorExit)
//C           (JNIEnv *env, jobject obj);

//C         jint (JNICALL *GetJavaVM)
//C           (JNIEnv *env, JavaVM **vm);

//C         void (JNICALL *GetStringRegion)
//C           (JNIEnv *env, jstring str, jsize start, jsize len, jchar *buf);
//C         void (JNICALL *GetStringUTFRegion)
//C           (JNIEnv *env, jstring str, jsize start, jsize len, char *buf);

//C         void * (JNICALL *GetPrimitiveArrayCritical)
//C           (JNIEnv *env, jarray array, jboolean *isCopy);
//C         void (JNICALL *ReleasePrimitiveArrayCritical)
//C           (JNIEnv *env, jarray array, void *carray, jint mode);

//C         const jchar * (JNICALL *GetStringCritical)
//C           (JNIEnv *env, jstring string, jboolean *isCopy);
//C         void (JNICALL *ReleaseStringCritical)
//C           (JNIEnv *env, jstring string, const jchar *cstring);

//C         jweak (JNICALL *NewWeakGlobalRef)
//C            (JNIEnv *env, jobject obj);
//C         void (JNICALL *DeleteWeakGlobalRef)
//C            (JNIEnv *env, jweak ref);

//C         jboolean (JNICALL *ExceptionCheck)
//C            (JNIEnv *env);

//C         jobject (JNICALL *NewDirectByteBuffer)
//C            (JNIEnv* env, void* address, jlong capacity);
//C         void* (JNICALL *GetDirectBufferAddress)
//C            (JNIEnv* env, jobject buf);
//C         jlong (JNICALL *GetDirectBufferCapacity)
//C            (JNIEnv* env, jobject buf);
//C     };
struct JNINativeInterface_
{
    void *reserved0;
    void *reserved1;
    void *reserved2;
    void *reserved3;
    jint  function(JNIEnv *env)GetVersion;
    jclass  function(JNIEnv *env, char *name, jobject loader, jbyte *buf, jsize len)DefineClass;
    jclass  function(JNIEnv *env, char *name)FindClass;
    jmethodID  function(JNIEnv *env, jobject method)FromReflectedMethod;
    jfieldID  function(JNIEnv *env, jobject field)FromReflectedField;
    jobject  function(JNIEnv *env, jclass cls, jmethodID methodID, jboolean isStatic)ToReflectedMethod;
    jclass  function(JNIEnv *env, jclass sub)GetSuperclass;
    jboolean  function(JNIEnv *env, jclass sub, jclass sup)IsAssignableFrom;
    jobject  function(JNIEnv *env, jclass cls, jfieldID fieldID, jboolean isStatic)ToReflectedField;
    jint  function(JNIEnv *env, jthrowable obj)Throw;
    jint  function(JNIEnv *env, jclass clazz, char *msg)ThrowNew;
    jthrowable  function(JNIEnv *env)ExceptionOccurred;
    void  function(JNIEnv *env)ExceptionDescribe;
    void  function(JNIEnv *env)ExceptionClear;
    void  function(JNIEnv *env, char *msg)FatalError;
    jint  function(JNIEnv *env, jint capacity)PushLocalFrame;
    jobject  function(JNIEnv *env, jobject result)PopLocalFrame;
    jobject  function(JNIEnv *env, jobject lobj)NewGlobalRef;
    void  function(JNIEnv *env, jobject gref)DeleteGlobalRef;
    void  function(JNIEnv *env, jobject obj)DeleteLocalRef;
    jboolean  function(JNIEnv *env, jobject obj1, jobject obj2)IsSameObject;
    jobject  function(JNIEnv *env, jobject ref)NewLocalRef;
    jint  function(JNIEnv *env, jint capacity)EnsureLocalCapacity;
    jobject  function(JNIEnv *env, jclass clazz)AllocObject;
    jobject  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)NewObject;
    jobject  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)NewObjectV;
    jobject  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)NewObjectA;
    jclass  function(JNIEnv *env, jobject obj)GetObjectClass;
    jboolean  function(JNIEnv *env, jobject obj, jclass clazz)IsInstanceOf;
    jmethodID  function(JNIEnv *env, jclass clazz, char *name, char *sig)GetMethodID;
    jobject  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallObjectMethod;
    jobject  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallObjectMethodV;
    jobject  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallObjectMethodA;
    jboolean  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallBooleanMethod;
    jboolean  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallBooleanMethodV;
    jboolean  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallBooleanMethodA;
    jbyte  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallByteMethod;
    jbyte  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallByteMethodV;
    jbyte  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallByteMethodA;
    jchar  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallCharMethod;
    jchar  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallCharMethodV;
    jchar  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallCharMethodA;
    jshort  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallShortMethod;
    jshort  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallShortMethodV;
    jshort  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallShortMethodA;
    jint  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallIntMethod;
    jint  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallIntMethodV;
    jint  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallIntMethodA;
    jlong  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallLongMethod;
    jlong  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallLongMethodV;
    jlong  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallLongMethodA;
    jfloat  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallFloatMethod;
    jfloat  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallFloatMethodV;
    jfloat  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallFloatMethodA;
    jdouble  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallDoubleMethod;
    jdouble  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallDoubleMethodV;
    jdouble  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallDoubleMethodA;
    void  function(JNIEnv *env, jobject obj, jmethodID methodID,...)CallVoidMethod;
    void  function(JNIEnv *env, jobject obj, jmethodID methodID, va_list args)CallVoidMethodV;
    void  function(JNIEnv *env, jobject obj, jmethodID methodID, jvalue *args)CallVoidMethodA;
    jobject  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualObjectMethod;
    jobject  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualObjectMethodV;
    jobject  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualObjectMethodA;
    jboolean  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualBooleanMethod;
    jboolean  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualBooleanMethodV;
    jboolean  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualBooleanMethodA;
    jbyte  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualByteMethod;
    jbyte  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualByteMethodV;
    jbyte  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualByteMethodA;
    jchar  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualCharMethod;
    jchar  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualCharMethodV;
    jchar  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualCharMethodA;
    jshort  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualShortMethod;
    jshort  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualShortMethodV;
    jshort  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualShortMethodA;
    jint  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualIntMethod;
    jint  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualIntMethodV;
    jint  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualIntMethodA;
    jlong  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualLongMethod;
    jlong  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualLongMethodV;
    jlong  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualLongMethodA;
    jfloat  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualFloatMethod;
    jfloat  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualFloatMethodV;
    jfloat  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualFloatMethodA;
    jdouble  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualDoubleMethod;
    jdouble  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualDoubleMethodV;
    jdouble  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualDoubleMethodA;
    void  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID,...)CallNonvirtualVoidMethod;
    void  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args)CallNonvirtualVoidMethodV;
    void  function(JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, jvalue *args)CallNonvirtualVoidMethodA;
    jfieldID  function(JNIEnv *env, jclass clazz, char *name, char *sig)GetFieldID;
    jobject  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetObjectField;
    jboolean  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetBooleanField;
    jbyte  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetByteField;
    jchar  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetCharField;
    jshort  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetShortField;
    jint  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetIntField;
    jlong  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetLongField;
    jfloat  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetFloatField;
    jdouble  function(JNIEnv *env, jobject obj, jfieldID fieldID)GetDoubleField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jobject val)SetObjectField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jboolean val)SetBooleanField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jbyte val)SetByteField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jchar val)SetCharField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jshort val)SetShortField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jint val)SetIntField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jlong val)SetLongField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jfloat val)SetFloatField;
    void  function(JNIEnv *env, jobject obj, jfieldID fieldID, jdouble val)SetDoubleField;
    jmethodID  function(JNIEnv *env, jclass clazz, char *name, char *sig)GetStaticMethodID;
    jobject  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticObjectMethod;
    jobject  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticObjectMethodV;
    jobject  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticObjectMethodA;
    jboolean  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticBooleanMethod;
    jboolean  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticBooleanMethodV;
    jboolean  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticBooleanMethodA;
    jbyte  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticByteMethod;
    jbyte  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticByteMethodV;
    jbyte  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticByteMethodA;
    jchar  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticCharMethod;
    jchar  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticCharMethodV;
    jchar  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticCharMethodA;
    jshort  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticShortMethod;
    jshort  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticShortMethodV;
    jshort  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticShortMethodA;
    jint  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticIntMethod;
    jint  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticIntMethodV;
    jint  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticIntMethodA;
    jlong  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticLongMethod;
    jlong  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticLongMethodV;
    jlong  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticLongMethodA;
    jfloat  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticFloatMethod;
    jfloat  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticFloatMethodV;
    jfloat  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticFloatMethodA;
    jdouble  function(JNIEnv *env, jclass clazz, jmethodID methodID,...)CallStaticDoubleMethod;
    jdouble  function(JNIEnv *env, jclass clazz, jmethodID methodID, va_list args)CallStaticDoubleMethodV;
    jdouble  function(JNIEnv *env, jclass clazz, jmethodID methodID, jvalue *args)CallStaticDoubleMethodA;
    void  function(JNIEnv *env, jclass cls, jmethodID methodID,...)CallStaticVoidMethod;
    void  function(JNIEnv *env, jclass cls, jmethodID methodID, va_list args)CallStaticVoidMethodV;
    void  function(JNIEnv *env, jclass cls, jmethodID methodID, jvalue *args)CallStaticVoidMethodA;
    jfieldID  function(JNIEnv *env, jclass clazz, char *name, char *sig)GetStaticFieldID;
    jobject  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticObjectField;
    jboolean  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticBooleanField;
    jbyte  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticByteField;
    jchar  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticCharField;
    jshort  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticShortField;
    jint  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticIntField;
    jlong  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticLongField;
    jfloat  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticFloatField;
    jdouble  function(JNIEnv *env, jclass clazz, jfieldID fieldID)GetStaticDoubleField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jobject value)SetStaticObjectField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jboolean value)SetStaticBooleanField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jbyte value)SetStaticByteField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jchar value)SetStaticCharField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jshort value)SetStaticShortField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jint value)SetStaticIntField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jlong value)SetStaticLongField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jfloat value)SetStaticFloatField;
    void  function(JNIEnv *env, jclass clazz, jfieldID fieldID, jdouble value)SetStaticDoubleField;
    jstring  function(JNIEnv *env, jchar *unicode, jsize len)NewString;
    jsize  function(JNIEnv *env, jstring str)GetStringLength;
    jchar * function(JNIEnv *env, jstring str, jboolean *isCopy)GetStringChars;
    void  function(JNIEnv *env, jstring str, jchar *chars)ReleaseStringChars;
    jstring  function(JNIEnv *env, char *utf)NewStringUTF;
    jsize  function(JNIEnv *env, jstring str)GetStringUTFLength;
    char * function(JNIEnv *env, jstring str, jboolean *isCopy)GetStringUTFChars;
    void  function(JNIEnv *env, jstring str, char *chars)ReleaseStringUTFChars;
    jsize  function(JNIEnv *env, jarray array)GetArrayLength;
    jobjectArray  function(JNIEnv *env, jsize len, jclass clazz, jobject init)NewObjectArray;
    jobject  function(JNIEnv *env, jobjectArray array, jsize index)GetObjectArrayElement;
    void  function(JNIEnv *env, jobjectArray array, jsize index, jobject val)SetObjectArrayElement;
    jbooleanArray  function(JNIEnv *env, jsize len)NewBooleanArray;
    jbyteArray  function(JNIEnv *env, jsize len)NewByteArray;
    jcharArray  function(JNIEnv *env, jsize len)NewCharArray;
    jshortArray  function(JNIEnv *env, jsize len)NewShortArray;
    jintArray  function(JNIEnv *env, jsize len)NewIntArray;
    jlongArray  function(JNIEnv *env, jsize len)NewLongArray;
    jfloatArray  function(JNIEnv *env, jsize len)NewFloatArray;
    jdoubleArray  function(JNIEnv *env, jsize len)NewDoubleArray;
    jboolean * function(JNIEnv *env, jbooleanArray array, jboolean *isCopy)GetBooleanArrayElements;
    jbyte * function(JNIEnv *env, jbyteArray array, jboolean *isCopy)GetByteArrayElements;
    jchar * function(JNIEnv *env, jcharArray array, jboolean *isCopy)GetCharArrayElements;
    jshort * function(JNIEnv *env, jshortArray array, jboolean *isCopy)GetShortArrayElements;
    jint * function(JNIEnv *env, jintArray array, jboolean *isCopy)GetIntArrayElements;
    jlong * function(JNIEnv *env, jlongArray array, jboolean *isCopy)GetLongArrayElements;
    jfloat * function(JNIEnv *env, jfloatArray array, jboolean *isCopy)GetFloatArrayElements;
    jdouble * function(JNIEnv *env, jdoubleArray array, jboolean *isCopy)GetDoubleArrayElements;
    void  function(JNIEnv *env, jbooleanArray array, jboolean *elems, jint mode)ReleaseBooleanArrayElements;
    void  function(JNIEnv *env, jbyteArray array, jbyte *elems, jint mode)ReleaseByteArrayElements;
    void  function(JNIEnv *env, jcharArray array, jchar *elems, jint mode)ReleaseCharArrayElements;
    void  function(JNIEnv *env, jshortArray array, jshort *elems, jint mode)ReleaseShortArrayElements;
    void  function(JNIEnv *env, jintArray array, jint *elems, jint mode)ReleaseIntArrayElements;
    void  function(JNIEnv *env, jlongArray array, jlong *elems, jint mode)ReleaseLongArrayElements;
    void  function(JNIEnv *env, jfloatArray array, jfloat *elems, jint mode)ReleaseFloatArrayElements;
    void  function(JNIEnv *env, jdoubleArray array, jdouble *elems, jint mode)ReleaseDoubleArrayElements;
    void  function(JNIEnv *env, jbooleanArray array, jsize start, jsize l, jboolean *buf)GetBooleanArrayRegion;
    void  function(JNIEnv *env, jbyteArray array, jsize start, jsize len, jbyte *buf)GetByteArrayRegion;
    void  function(JNIEnv *env, jcharArray array, jsize start, jsize len, jchar *buf)GetCharArrayRegion;
    void  function(JNIEnv *env, jshortArray array, jsize start, jsize len, jshort *buf)GetShortArrayRegion;
    void  function(JNIEnv *env, jintArray array, jsize start, jsize len, jint *buf)GetIntArrayRegion;
    void  function(JNIEnv *env, jlongArray array, jsize start, jsize len, jlong *buf)GetLongArrayRegion;
    void  function(JNIEnv *env, jfloatArray array, jsize start, jsize len, jfloat *buf)GetFloatArrayRegion;
    void  function(JNIEnv *env, jdoubleArray array, jsize start, jsize len, jdouble *buf)GetDoubleArrayRegion;
    void  function(JNIEnv *env, jbooleanArray array, jsize start, jsize l, jboolean *buf)SetBooleanArrayRegion;
    void  function(JNIEnv *env, jbyteArray array, jsize start, jsize len, jbyte *buf)SetByteArrayRegion;
    void  function(JNIEnv *env, jcharArray array, jsize start, jsize len, jchar *buf)SetCharArrayRegion;
    void  function(JNIEnv *env, jshortArray array, jsize start, jsize len, jshort *buf)SetShortArrayRegion;
    void  function(JNIEnv *env, jintArray array, jsize start, jsize len, jint *buf)SetIntArrayRegion;
    void  function(JNIEnv *env, jlongArray array, jsize start, jsize len, jlong *buf)SetLongArrayRegion;
    void  function(JNIEnv *env, jfloatArray array, jsize start, jsize len, jfloat *buf)SetFloatArrayRegion;
    void  function(JNIEnv *env, jdoubleArray array, jsize start, jsize len, jdouble *buf)SetDoubleArrayRegion;
    jint  function(JNIEnv *env, jclass clazz, JNINativeMethod *methods, jint nMethods)RegisterNatives;
    jint  function(JNIEnv *env, jclass clazz)UnregisterNatives;
    jint  function(JNIEnv *env, jobject obj)MonitorEnter;
    jint  function(JNIEnv *env, jobject obj)MonitorExit;
    jint  function(JNIEnv *env, JavaVM **vm)GetJavaVM;
    void  function(JNIEnv *env, jstring str, jsize start, jsize len, jchar *buf)GetStringRegion;
    void  function(JNIEnv *env, jstring str, jsize start, jsize len, char *buf)GetStringUTFRegion;
    void * function(JNIEnv *env, jarray array, jboolean *isCopy)GetPrimitiveArrayCritical;
    void  function(JNIEnv *env, jarray array, void *carray, jint mode)ReleasePrimitiveArrayCritical;
    jchar * function(JNIEnv *env, jstring string, jboolean *isCopy)GetStringCritical;
    void  function(JNIEnv *env, jstring string, jchar *cstring)ReleaseStringCritical;
    jweak  function(JNIEnv *env, jobject obj)NewWeakGlobalRef;
    void  function(JNIEnv *env, jweak ref)DeleteWeakGlobalRef;
    jboolean  function(JNIEnv *env)ExceptionCheck;
    jobject  function(JNIEnv *env, void *address, jlong capacity)NewDirectByteBuffer;
    void * function(JNIEnv *env, jobject buf)GetDirectBufferAddress;
    jlong  function(JNIEnv *env, jobject buf)GetDirectBufferCapacity;
}

/*
 * We use inlined functions for C++ so that programmers can write:
 *
 *    env->FindClass("java/lang/String")
 *
 * in C++ rather than:
 *
 *    (*env)->FindClass(env, "java/lang/String")
 *
 * in C.
 */

//C     struct JNIEnv_ {
//C         const struct JNINativeInterface_ *functions;
//C     #ifdef __cplusplus

//C         jint GetVersion() {
//C             return functions->GetVersion(this);
//C         }
//C         jclass DefineClass(const char *name, jobject loader, const jbyte *buf,
//C     		       jsize len) {
//C             return functions->DefineClass(this, name, loader, buf, len);
//C         }
//C         jclass FindClass(const char *name) {
//C             return functions->FindClass(this, name);
//C         }
//C         jmethodID FromReflectedMethod(jobject method) {
//C             return functions->FromReflectedMethod(this,method);
//C         }
//C         jfieldID FromReflectedField(jobject field) {
//C             return functions->FromReflectedField(this,field);
//C         }

//C         jobject ToReflectedMethod(jclass cls, jmethodID methodID, jboolean isStatic) {
//C             return functions->ToReflectedMethod(this, cls, methodID, isStatic);
//C         }

//C         jclass GetSuperclass(jclass sub) {
//C             return functions->GetSuperclass(this, sub);
//C         }
//C         jboolean IsAssignableFrom(jclass sub, jclass sup) {
//C             return functions->IsAssignableFrom(this, sub, sup);
//C         }

//C         jobject ToReflectedField(jclass cls, jfieldID fieldID, jboolean isStatic) {
//C             return functions->ToReflectedField(this,cls,fieldID,isStatic);
//C         }

//C         jint Throw(jthrowable obj) {
//C             return functions->Throw(this, obj);
//C         }
//C         jint ThrowNew(jclass clazz, const char *msg) {
//C             return functions->ThrowNew(this, clazz, msg);
//C         }
//C         jthrowable ExceptionOccurred() {
//C             return functions->ExceptionOccurred(this);
//C         }
//C         void ExceptionDescribe() {
//C             functions->ExceptionDescribe(this);
//C         }
//C         void ExceptionClear() {
//C             functions->ExceptionClear(this);
//C         }
//C         void FatalError(const char *msg) {
//C             functions->FatalError(this, msg);
//C         }

//C         jint PushLocalFrame(jint capacity) {
//C             return functions->PushLocalFrame(this,capacity);
//C         }
//C         jobject PopLocalFrame(jobject result) {
//C             return functions->PopLocalFrame(this,result);
//C         }

//C         jobject NewGlobalRef(jobject lobj) {
//C             return functions->NewGlobalRef(this,lobj);
//C         }
//C         void DeleteGlobalRef(jobject gref) {
//C             functions->DeleteGlobalRef(this,gref);
//C         }
//C         void DeleteLocalRef(jobject obj) {
//C             functions->DeleteLocalRef(this, obj);
//C         }

//C         jboolean IsSameObject(jobject obj1, jobject obj2) {
//C             return functions->IsSameObject(this,obj1,obj2);
//C         }

//C         jobject NewLocalRef(jobject ref) {
//C             return functions->NewLocalRef(this,ref);
//C         }
//C         jint EnsureLocalCapacity(jint capacity) {
//C             return functions->EnsureLocalCapacity(this,capacity);
//C         }

//C         jobject AllocObject(jclass clazz) {
//C             return functions->AllocObject(this,clazz);
//C         }
//C         jobject NewObject(jclass clazz, jmethodID methodID, ...) {
//C             va_list args;
//C     	jobject result;
//C     	va_start(args, methodID);
//C             result = functions->NewObjectV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jobject NewObjectV(jclass clazz, jmethodID methodID,
//C     		       va_list args) {
//C             return functions->NewObjectV(this,clazz,methodID,args);
//C         }
//C         jobject NewObjectA(jclass clazz, jmethodID methodID,
//C     		       const jvalue *args) {
//C             return functions->NewObjectA(this,clazz,methodID,args);
//C         }

//C         jclass GetObjectClass(jobject obj) {
//C             return functions->GetObjectClass(this,obj);
//C         }
//C         jboolean IsInstanceOf(jobject obj, jclass clazz) {
//C             return functions->IsInstanceOf(this,obj,clazz);
//C         }

//C         jmethodID GetMethodID(jclass clazz, const char *name,
//C     			  const char *sig) {
//C             return functions->GetMethodID(this,clazz,name,sig);
//C         }

//C         jobject CallObjectMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jobject result;
//C     	va_start(args,methodID);
//C     	result = functions->CallObjectMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jobject CallObjectMethodV(jobject obj, jmethodID methodID,
//C     			va_list args) {
//C             return functions->CallObjectMethodV(this,obj,methodID,args);
//C         }
//C         jobject CallObjectMethodA(jobject obj, jmethodID methodID,
//C     			const jvalue * args) {
//C             return functions->CallObjectMethodA(this,obj,methodID,args);
//C         }

//C         jboolean CallBooleanMethod(jobject obj,
//C     			       jmethodID methodID, ...) {
//C             va_list args;
//C     	jboolean result;
//C     	va_start(args,methodID);
//C     	result = functions->CallBooleanMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jboolean CallBooleanMethodV(jobject obj, jmethodID methodID,
//C     				va_list args) {
//C             return functions->CallBooleanMethodV(this,obj,methodID,args);
//C         }
//C         jboolean CallBooleanMethodA(jobject obj, jmethodID methodID,
//C     				const jvalue * args) {
//C             return functions->CallBooleanMethodA(this,obj,methodID, args);
//C         }

//C         jbyte CallByteMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jbyte result;
//C     	va_start(args,methodID);
//C     	result = functions->CallByteMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jbyte CallByteMethodV(jobject obj, jmethodID methodID,
//C     			  va_list args) {
//C             return functions->CallByteMethodV(this,obj,methodID,args);
//C         }
//C         jbyte CallByteMethodA(jobject obj, jmethodID methodID,
//C     			  const jvalue * args) {
//C             return functions->CallByteMethodA(this,obj,methodID,args);
//C         }

//C         jchar CallCharMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jchar result;
//C     	va_start(args,methodID);
//C     	result = functions->CallCharMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jchar CallCharMethodV(jobject obj, jmethodID methodID,
//C     			  va_list args) {
//C             return functions->CallCharMethodV(this,obj,methodID,args);
//C         }
//C         jchar CallCharMethodA(jobject obj, jmethodID methodID,
//C     			  const jvalue * args) {
//C             return functions->CallCharMethodA(this,obj,methodID,args);
//C         }

//C         jshort CallShortMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jshort result;
//C     	va_start(args,methodID);
//C     	result = functions->CallShortMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jshort CallShortMethodV(jobject obj, jmethodID methodID,
//C     			    va_list args) {
//C             return functions->CallShortMethodV(this,obj,methodID,args);
//C         }
//C         jshort CallShortMethodA(jobject obj, jmethodID methodID,
//C     			    const jvalue * args) {
//C             return functions->CallShortMethodA(this,obj,methodID,args);
//C         }

//C         jint CallIntMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jint result;
//C     	va_start(args,methodID);
//C     	result = functions->CallIntMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jint CallIntMethodV(jobject obj, jmethodID methodID,
//C     			va_list args) {
//C             return functions->CallIntMethodV(this,obj,methodID,args);
//C         }
//C         jint CallIntMethodA(jobject obj, jmethodID methodID,
//C     			const jvalue * args) {
//C             return functions->CallIntMethodA(this,obj,methodID,args);
//C         }

//C         jlong CallLongMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jlong result;
//C     	va_start(args,methodID);
//C     	result = functions->CallLongMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jlong CallLongMethodV(jobject obj, jmethodID methodID,
//C     			  va_list args) {
//C             return functions->CallLongMethodV(this,obj,methodID,args);
//C         }
//C         jlong CallLongMethodA(jobject obj, jmethodID methodID,
//C     			  const jvalue * args) {
//C             return functions->CallLongMethodA(this,obj,methodID,args);
//C         }

//C         jfloat CallFloatMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jfloat result;
//C     	va_start(args,methodID);
//C     	result = functions->CallFloatMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jfloat CallFloatMethodV(jobject obj, jmethodID methodID,
//C     			    va_list args) {
//C             return functions->CallFloatMethodV(this,obj,methodID,args);
//C         }
//C         jfloat CallFloatMethodA(jobject obj, jmethodID methodID,
//C     			    const jvalue * args) {
//C             return functions->CallFloatMethodA(this,obj,methodID,args);
//C         }

//C         jdouble CallDoubleMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	jdouble result;
//C     	va_start(args,methodID);
//C     	result = functions->CallDoubleMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jdouble CallDoubleMethodV(jobject obj, jmethodID methodID,
//C     			va_list args) {
//C             return functions->CallDoubleMethodV(this,obj,methodID,args);
//C         }
//C         jdouble CallDoubleMethodA(jobject obj, jmethodID methodID,
//C     			const jvalue * args) {
//C             return functions->CallDoubleMethodA(this,obj,methodID,args);
//C         }

//C         void CallVoidMethod(jobject obj, jmethodID methodID, ...) {
//C             va_list args;
//C     	va_start(args,methodID);
//C     	functions->CallVoidMethodV(this,obj,methodID,args);
//C     	va_end(args);
//C         }
//C         void CallVoidMethodV(jobject obj, jmethodID methodID,
//C     			 va_list args) {
//C             functions->CallVoidMethodV(this,obj,methodID,args);
//C         }
//C         void CallVoidMethodA(jobject obj, jmethodID methodID,
//C     			 const jvalue * args) {
//C             functions->CallVoidMethodA(this,obj,methodID,args);
//C         }

//C         jobject CallNonvirtualObjectMethod(jobject obj, jclass clazz,
//C     				       jmethodID methodID, ...) {
//C             va_list args;
//C     	jobject result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualObjectMethodV(this,obj,clazz,
//C     							methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jobject CallNonvirtualObjectMethodV(jobject obj, jclass clazz,
//C     					jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualObjectMethodV(this,obj,clazz,
//C     						      methodID,args);
//C         }
//C         jobject CallNonvirtualObjectMethodA(jobject obj, jclass clazz,
//C     					jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualObjectMethodA(this,obj,clazz,
//C     						      methodID,args);
//C         }

//C         jboolean CallNonvirtualBooleanMethod(jobject obj, jclass clazz,
//C     					 jmethodID methodID, ...) {
//C             va_list args;
//C     	jboolean result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualBooleanMethodV(this,obj,clazz,
//C     							 methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jboolean CallNonvirtualBooleanMethodV(jobject obj, jclass clazz,
//C     					  jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualBooleanMethodV(this,obj,clazz,
//C     						       methodID,args);
//C         }
//C         jboolean CallNonvirtualBooleanMethodA(jobject obj, jclass clazz,
//C     					  jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualBooleanMethodA(this,obj,clazz,
//C     						       methodID, args);
//C         }

//C         jbyte CallNonvirtualByteMethod(jobject obj, jclass clazz,
//C     				   jmethodID methodID, ...) {
//C             va_list args;
//C     	jbyte result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualByteMethodV(this,obj,clazz,
//C     						      methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jbyte CallNonvirtualByteMethodV(jobject obj, jclass clazz,
//C     				    jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualByteMethodV(this,obj,clazz,
//C     						    methodID,args);
//C         }
//C         jbyte CallNonvirtualByteMethodA(jobject obj, jclass clazz,
//C     				    jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualByteMethodA(this,obj,clazz,
//C     						    methodID,args);
//C         }

//C         jchar CallNonvirtualCharMethod(jobject obj, jclass clazz,
//C     				   jmethodID methodID, ...) {
//C             va_list args;
//C     	jchar result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualCharMethodV(this,obj,clazz,
//C     						      methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jchar CallNonvirtualCharMethodV(jobject obj, jclass clazz,
//C     				    jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualCharMethodV(this,obj,clazz,
//C     						    methodID,args);
//C         }
//C         jchar CallNonvirtualCharMethodA(jobject obj, jclass clazz,
//C     				    jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualCharMethodA(this,obj,clazz,
//C     						    methodID,args);
//C         }

//C         jshort CallNonvirtualShortMethod(jobject obj, jclass clazz,
//C     				     jmethodID methodID, ...) {
//C             va_list args;
//C     	jshort result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualShortMethodV(this,obj,clazz,
//C     						       methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jshort CallNonvirtualShortMethodV(jobject obj, jclass clazz,
//C     				      jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualShortMethodV(this,obj,clazz,
//C     						     methodID,args);
//C         }
//C         jshort CallNonvirtualShortMethodA(jobject obj, jclass clazz,
//C     				      jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualShortMethodA(this,obj,clazz,
//C     						     methodID,args);
//C         }

//C         jint CallNonvirtualIntMethod(jobject obj, jclass clazz,
//C     				 jmethodID methodID, ...) {
//C             va_list args;
//C     	jint result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualIntMethodV(this,obj,clazz,
//C     						     methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jint CallNonvirtualIntMethodV(jobject obj, jclass clazz,
//C     				  jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualIntMethodV(this,obj,clazz,
//C     						   methodID,args);
//C         }
//C         jint CallNonvirtualIntMethodA(jobject obj, jclass clazz,
//C     				  jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualIntMethodA(this,obj,clazz,
//C     						   methodID,args);
//C         }

//C         jlong CallNonvirtualLongMethod(jobject obj, jclass clazz,
//C     				   jmethodID methodID, ...) {
//C             va_list args;
//C     	jlong result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualLongMethodV(this,obj,clazz,
//C     						      methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jlong CallNonvirtualLongMethodV(jobject obj, jclass clazz,
//C     				    jmethodID methodID, va_list args) {
//C             return functions->CallNonvirtualLongMethodV(this,obj,clazz,
//C     						    methodID,args);
//C         }
//C         jlong CallNonvirtualLongMethodA(jobject obj, jclass clazz,
//C     				    jmethodID methodID, const jvalue * args) {
//C             return functions->CallNonvirtualLongMethodA(this,obj,clazz,
//C     						    methodID,args);
//C         }

//C         jfloat CallNonvirtualFloatMethod(jobject obj, jclass clazz,
//C     				     jmethodID methodID, ...) {
//C             va_list args;
//C     	jfloat result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualFloatMethodV(this,obj,clazz,
//C     						       methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jfloat CallNonvirtualFloatMethodV(jobject obj, jclass clazz,
//C     				      jmethodID methodID,
//C     				      va_list args) {
//C             return functions->CallNonvirtualFloatMethodV(this,obj,clazz,
//C     						     methodID,args);
//C         }
//C         jfloat CallNonvirtualFloatMethodA(jobject obj, jclass clazz,
//C     				      jmethodID methodID,
//C     				      const jvalue * args) {
//C             return functions->CallNonvirtualFloatMethodA(this,obj,clazz,
//C     						     methodID,args);
//C         }

//C         jdouble CallNonvirtualDoubleMethod(jobject obj, jclass clazz,
//C     				       jmethodID methodID, ...) {
//C             va_list args;
//C     	jdouble result;
//C     	va_start(args,methodID);
//C     	result = functions->CallNonvirtualDoubleMethodV(this,obj,clazz,
//C     							methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jdouble CallNonvirtualDoubleMethodV(jobject obj, jclass clazz,
//C     					jmethodID methodID,
//C     					va_list args) {
//C             return functions->CallNonvirtualDoubleMethodV(this,obj,clazz,
//C     						      methodID,args);
//C         }
//C         jdouble CallNonvirtualDoubleMethodA(jobject obj, jclass clazz,
//C     					jmethodID methodID,
//C     					const jvalue * args) {
//C             return functions->CallNonvirtualDoubleMethodA(this,obj,clazz,
//C     						      methodID,args);
//C         }

//C         void CallNonvirtualVoidMethod(jobject obj, jclass clazz,
//C     				  jmethodID methodID, ...) {
//C             va_list args;
//C     	va_start(args,methodID);
//C     	functions->CallNonvirtualVoidMethodV(this,obj,clazz,methodID,args);
//C     	va_end(args);
//C         }
//C         void CallNonvirtualVoidMethodV(jobject obj, jclass clazz,
//C     				   jmethodID methodID,
//C     				   va_list args) {
//C             functions->CallNonvirtualVoidMethodV(this,obj,clazz,methodID,args);
//C         }
//C         void CallNonvirtualVoidMethodA(jobject obj, jclass clazz,
//C     				   jmethodID methodID,
//C     				   const jvalue * args) {
//C             functions->CallNonvirtualVoidMethodA(this,obj,clazz,methodID,args);
//C         }

//C         jfieldID GetFieldID(jclass clazz, const char *name,
//C     			const char *sig) {
//C             return functions->GetFieldID(this,clazz,name,sig);
//C         }

//C         jobject GetObjectField(jobject obj, jfieldID fieldID) {
//C             return functions->GetObjectField(this,obj,fieldID);
//C         }
//C         jboolean GetBooleanField(jobject obj, jfieldID fieldID) {
//C             return functions->GetBooleanField(this,obj,fieldID);
//C         }
//C         jbyte GetByteField(jobject obj, jfieldID fieldID) {
//C             return functions->GetByteField(this,obj,fieldID);
//C         }
//C         jchar GetCharField(jobject obj, jfieldID fieldID) {
//C             return functions->GetCharField(this,obj,fieldID);
//C         }
//C         jshort GetShortField(jobject obj, jfieldID fieldID) {
//C             return functions->GetShortField(this,obj,fieldID);
//C         }
//C         jint GetIntField(jobject obj, jfieldID fieldID) {
//C             return functions->GetIntField(this,obj,fieldID);
//C         }
//C         jlong GetLongField(jobject obj, jfieldID fieldID) {
//C             return functions->GetLongField(this,obj,fieldID);
//C         }
//C         jfloat GetFloatField(jobject obj, jfieldID fieldID) {
//C             return functions->GetFloatField(this,obj,fieldID);
//C         }
//C         jdouble GetDoubleField(jobject obj, jfieldID fieldID) {
//C             return functions->GetDoubleField(this,obj,fieldID);
//C         }

//C         void SetObjectField(jobject obj, jfieldID fieldID, jobject val) {
//C             functions->SetObjectField(this,obj,fieldID,val);
//C         }
//C         void SetBooleanField(jobject obj, jfieldID fieldID,
//C     			 jboolean val) {
//C             functions->SetBooleanField(this,obj,fieldID,val);
//C         }
//C         void SetByteField(jobject obj, jfieldID fieldID,
//C     		      jbyte val) {
//C             functions->SetByteField(this,obj,fieldID,val);
//C         }
//C         void SetCharField(jobject obj, jfieldID fieldID,
//C     		      jchar val) {
//C             functions->SetCharField(this,obj,fieldID,val);
//C         }
//C         void SetShortField(jobject obj, jfieldID fieldID,
//C     		       jshort val) {
//C             functions->SetShortField(this,obj,fieldID,val);
//C         }
//C         void SetIntField(jobject obj, jfieldID fieldID,
//C     		     jint val) {
//C             functions->SetIntField(this,obj,fieldID,val);
//C         }
//C         void SetLongField(jobject obj, jfieldID fieldID,
//C     		      jlong val) {
//C             functions->SetLongField(this,obj,fieldID,val);
//C         }
//C         void SetFloatField(jobject obj, jfieldID fieldID,
//C     		       jfloat val) {
//C             functions->SetFloatField(this,obj,fieldID,val);
//C         }
//C         void SetDoubleField(jobject obj, jfieldID fieldID,
//C     			jdouble val) {
//C             functions->SetDoubleField(this,obj,fieldID,val);
//C         }

//C         jmethodID GetStaticMethodID(jclass clazz, const char *name,
//C     				const char *sig) {
//C             return functions->GetStaticMethodID(this,clazz,name,sig);
//C         }

//C         jobject CallStaticObjectMethod(jclass clazz, jmethodID methodID,
//C     			     ...) {
//C             va_list args;
//C     	jobject result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticObjectMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jobject CallStaticObjectMethodV(jclass clazz, jmethodID methodID,
//C     			      va_list args) {
//C             return functions->CallStaticObjectMethodV(this,clazz,methodID,args);
//C         }
//C         jobject CallStaticObjectMethodA(jclass clazz, jmethodID methodID,
//C     			      const jvalue *args) {
//C             return functions->CallStaticObjectMethodA(this,clazz,methodID,args);
//C         }

//C         jboolean CallStaticBooleanMethod(jclass clazz,
//C     				     jmethodID methodID, ...) {
//C             va_list args;
//C     	jboolean result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticBooleanMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jboolean CallStaticBooleanMethodV(jclass clazz,
//C     				      jmethodID methodID, va_list args) {
//C             return functions->CallStaticBooleanMethodV(this,clazz,methodID,args);
//C         }
//C         jboolean CallStaticBooleanMethodA(jclass clazz,
//C     				      jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticBooleanMethodA(this,clazz,methodID,args);
//C         }

//C         jbyte CallStaticByteMethod(jclass clazz,
//C     			       jmethodID methodID, ...) {
//C             va_list args;
//C     	jbyte result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticByteMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jbyte CallStaticByteMethodV(jclass clazz,
//C     				jmethodID methodID, va_list args) {
//C             return functions->CallStaticByteMethodV(this,clazz,methodID,args);
//C         }
//C         jbyte CallStaticByteMethodA(jclass clazz,
//C     				jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticByteMethodA(this,clazz,methodID,args);
//C         }

//C         jchar CallStaticCharMethod(jclass clazz,
//C     			       jmethodID methodID, ...) {
//C             va_list args;
//C     	jchar result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticCharMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jchar CallStaticCharMethodV(jclass clazz,
//C     				jmethodID methodID, va_list args) {
//C             return functions->CallStaticCharMethodV(this,clazz,methodID,args);
//C         }
//C         jchar CallStaticCharMethodA(jclass clazz,
//C     				jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticCharMethodA(this,clazz,methodID,args);
//C         }

//C         jshort CallStaticShortMethod(jclass clazz,
//C     				 jmethodID methodID, ...) {
//C             va_list args;
//C     	jshort result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticShortMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jshort CallStaticShortMethodV(jclass clazz,
//C     				  jmethodID methodID, va_list args) {
//C             return functions->CallStaticShortMethodV(this,clazz,methodID,args);
//C         }
//C         jshort CallStaticShortMethodA(jclass clazz,
//C     				  jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticShortMethodA(this,clazz,methodID,args);
//C         }

//C         jint CallStaticIntMethod(jclass clazz,
//C     			     jmethodID methodID, ...) {
//C             va_list args;
//C     	jint result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticIntMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jint CallStaticIntMethodV(jclass clazz,
//C     			      jmethodID methodID, va_list args) {
//C             return functions->CallStaticIntMethodV(this,clazz,methodID,args);
//C         }
//C         jint CallStaticIntMethodA(jclass clazz,
//C     			      jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticIntMethodA(this,clazz,methodID,args);
//C         }

//C         jlong CallStaticLongMethod(jclass clazz,
//C     			       jmethodID methodID, ...) {
//C             va_list args;
//C     	jlong result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticLongMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jlong CallStaticLongMethodV(jclass clazz,
//C     				jmethodID methodID, va_list args) {
//C             return functions->CallStaticLongMethodV(this,clazz,methodID,args);
//C         }
//C         jlong CallStaticLongMethodA(jclass clazz,
//C     				jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticLongMethodA(this,clazz,methodID,args);
//C         }

//C         jfloat CallStaticFloatMethod(jclass clazz,
//C     				 jmethodID methodID, ...) {
//C             va_list args;
//C     	jfloat result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticFloatMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jfloat CallStaticFloatMethodV(jclass clazz,
//C     				  jmethodID methodID, va_list args) {
//C             return functions->CallStaticFloatMethodV(this,clazz,methodID,args);
//C         }
//C         jfloat CallStaticFloatMethodA(jclass clazz,
//C     				  jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticFloatMethodA(this,clazz,methodID,args);
//C         }

//C         jdouble CallStaticDoubleMethod(jclass clazz,
//C     				   jmethodID methodID, ...) {
//C             va_list args;
//C     	jdouble result;
//C     	va_start(args,methodID);
//C     	result = functions->CallStaticDoubleMethodV(this,clazz,methodID,args);
//C     	va_end(args);
//C     	return result;
//C         }
//C         jdouble CallStaticDoubleMethodV(jclass clazz,
//C     				    jmethodID methodID, va_list args) {
//C             return functions->CallStaticDoubleMethodV(this,clazz,methodID,args);
//C         }
//C         jdouble CallStaticDoubleMethodA(jclass clazz,
//C     				    jmethodID methodID, const jvalue *args) {
//C             return functions->CallStaticDoubleMethodA(this,clazz,methodID,args);
//C         }

//C         void CallStaticVoidMethod(jclass cls, jmethodID methodID, ...) {
//C             va_list args;
//C     	va_start(args,methodID);
//C     	functions->CallStaticVoidMethodV(this,cls,methodID,args);
//C     	va_end(args);
//C         }
//C         void CallStaticVoidMethodV(jclass cls, jmethodID methodID,
//C     			       va_list args) {
//C             functions->CallStaticVoidMethodV(this,cls,methodID,args);
//C         }
//C         void CallStaticVoidMethodA(jclass cls, jmethodID methodID,
//C     			       const jvalue * args) {
//C             functions->CallStaticVoidMethodA(this,cls,methodID,args);
//C         }

//C         jfieldID GetStaticFieldID(jclass clazz, const char *name,
//C     			      const char *sig) {
//C             return functions->GetStaticFieldID(this,clazz,name,sig);
//C         }
//C         jobject GetStaticObjectField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticObjectField(this,clazz,fieldID);
//C         }
//C         jboolean GetStaticBooleanField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticBooleanField(this,clazz,fieldID);
//C         }
//C         jbyte GetStaticByteField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticByteField(this,clazz,fieldID);
//C         }
//C         jchar GetStaticCharField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticCharField(this,clazz,fieldID);
//C         }
//C         jshort GetStaticShortField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticShortField(this,clazz,fieldID);
//C         }
//C         jint GetStaticIntField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticIntField(this,clazz,fieldID);
//C         }
//C         jlong GetStaticLongField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticLongField(this,clazz,fieldID);
//C         }
//C         jfloat GetStaticFloatField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticFloatField(this,clazz,fieldID);
//C         }
//C         jdouble GetStaticDoubleField(jclass clazz, jfieldID fieldID) {
//C             return functions->GetStaticDoubleField(this,clazz,fieldID);
//C         }

//C         void SetStaticObjectField(jclass clazz, jfieldID fieldID,
//C     			jobject value) {
//C           functions->SetStaticObjectField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticBooleanField(jclass clazz, jfieldID fieldID,
//C     			jboolean value) {
//C           functions->SetStaticBooleanField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticByteField(jclass clazz, jfieldID fieldID,
//C     			jbyte value) {
//C           functions->SetStaticByteField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticCharField(jclass clazz, jfieldID fieldID,
//C     			jchar value) {
//C           functions->SetStaticCharField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticShortField(jclass clazz, jfieldID fieldID,
//C     			jshort value) {
//C           functions->SetStaticShortField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticIntField(jclass clazz, jfieldID fieldID,
//C     			jint value) {
//C           functions->SetStaticIntField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticLongField(jclass clazz, jfieldID fieldID,
//C     			jlong value) {
//C           functions->SetStaticLongField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticFloatField(jclass clazz, jfieldID fieldID,
//C     			jfloat value) {
//C           functions->SetStaticFloatField(this,clazz,fieldID,value);
//C         }
//C         void SetStaticDoubleField(jclass clazz, jfieldID fieldID,
//C     			jdouble value) {
//C           functions->SetStaticDoubleField(this,clazz,fieldID,value);
//C         }

//C         jstring NewString(const jchar *unicode, jsize len) {
//C             return functions->NewString(this,unicode,len);
//C         }
//C         jsize GetStringLength(jstring str) {
//C             return functions->GetStringLength(this,str);
//C         }
//C         const jchar *GetStringChars(jstring str, jboolean *isCopy) {
//C             return functions->GetStringChars(this,str,isCopy);
//C         }
//C         void ReleaseStringChars(jstring str, const jchar *chars) {
//C             functions->ReleaseStringChars(this,str,chars);
//C         }

//C         jstring NewStringUTF(const char *utf) {
//C             return functions->NewStringUTF(this,utf);
//C         }
//C         jsize GetStringUTFLength(jstring str) {
//C             return functions->GetStringUTFLength(this,str);
//C         }
//C         const char* GetStringUTFChars(jstring str, jboolean *isCopy) {
//C             return functions->GetStringUTFChars(this,str,isCopy);
//C         }
//C         void ReleaseStringUTFChars(jstring str, const char* chars) {
//C             functions->ReleaseStringUTFChars(this,str,chars);
//C         }

//C         jsize GetArrayLength(jarray array) {
//C             return functions->GetArrayLength(this,array);
//C         }

//C         jobjectArray NewObjectArray(jsize len, jclass clazz,
//C     				jobject init) {
//C             return functions->NewObjectArray(this,len,clazz,init);
//C         }
//C         jobject GetObjectArrayElement(jobjectArray array, jsize index) {
//C             return functions->GetObjectArrayElement(this,array,index);
//C         }
//C         void SetObjectArrayElement(jobjectArray array, jsize index,
//C     			       jobject val) {
//C             functions->SetObjectArrayElement(this,array,index,val);
//C         }

//C         jbooleanArray NewBooleanArray(jsize len) {
//C             return functions->NewBooleanArray(this,len);
//C         }
//C         jbyteArray NewByteArray(jsize len) {
//C             return functions->NewByteArray(this,len);
//C         }
//C         jcharArray NewCharArray(jsize len) {
//C             return functions->NewCharArray(this,len);
//C         }
//C         jshortArray NewShortArray(jsize len) {
//C             return functions->NewShortArray(this,len);
//C         }
//C         jintArray NewIntArray(jsize len) {
//C             return functions->NewIntArray(this,len);
//C         }
//C         jlongArray NewLongArray(jsize len) {
//C             return functions->NewLongArray(this,len);
//C         }
//C         jfloatArray NewFloatArray(jsize len) {
//C             return functions->NewFloatArray(this,len);
//C         }
//C         jdoubleArray NewDoubleArray(jsize len) {
//C             return functions->NewDoubleArray(this,len);
//C         }

//C         jboolean * GetBooleanArrayElements(jbooleanArray array, jboolean *isCopy) {
//C             return functions->GetBooleanArrayElements(this,array,isCopy);
//C         }
//C         jbyte * GetByteArrayElements(jbyteArray array, jboolean *isCopy) {
//C             return functions->GetByteArrayElements(this,array,isCopy);
//C         }
//C         jchar * GetCharArrayElements(jcharArray array, jboolean *isCopy) {
//C             return functions->GetCharArrayElements(this,array,isCopy);
//C         }
//C         jshort * GetShortArrayElements(jshortArray array, jboolean *isCopy) {
//C             return functions->GetShortArrayElements(this,array,isCopy);
//C         }
//C         jint * GetIntArrayElements(jintArray array, jboolean *isCopy) {
//C             return functions->GetIntArrayElements(this,array,isCopy);
//C         }
//C         jlong * GetLongArrayElements(jlongArray array, jboolean *isCopy) {
//C             return functions->GetLongArrayElements(this,array,isCopy);
//C         }
//C         jfloat * GetFloatArrayElements(jfloatArray array, jboolean *isCopy) {
//C             return functions->GetFloatArrayElements(this,array,isCopy);
//C         }
//C         jdouble * GetDoubleArrayElements(jdoubleArray array, jboolean *isCopy) {
//C             return functions->GetDoubleArrayElements(this,array,isCopy);
//C         }

//C         void ReleaseBooleanArrayElements(jbooleanArray array,
//C     				     jboolean *elems,
//C     				     jint mode) {
//C             functions->ReleaseBooleanArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseByteArrayElements(jbyteArray array,
//C     				  jbyte *elems,
//C     				  jint mode) {
//C             functions->ReleaseByteArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseCharArrayElements(jcharArray array,
//C     				  jchar *elems,
//C     				  jint mode) {
//C             functions->ReleaseCharArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseShortArrayElements(jshortArray array,
//C     				   jshort *elems,
//C     				   jint mode) {
//C             functions->ReleaseShortArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseIntArrayElements(jintArray array,
//C     				 jint *elems,
//C     				 jint mode) {
//C             functions->ReleaseIntArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseLongArrayElements(jlongArray array,
//C     				  jlong *elems,
//C     				  jint mode) {
//C             functions->ReleaseLongArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseFloatArrayElements(jfloatArray array,
//C     				   jfloat *elems,
//C     				   jint mode) {
//C             functions->ReleaseFloatArrayElements(this,array,elems,mode);
//C         }
//C         void ReleaseDoubleArrayElements(jdoubleArray array,
//C     				    jdouble *elems,
//C     				    jint mode) {
//C             functions->ReleaseDoubleArrayElements(this,array,elems,mode);
//C         }

//C         void GetBooleanArrayRegion(jbooleanArray array,
//C     			       jsize start, jsize len, jboolean *buf) {
//C             functions->GetBooleanArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetByteArrayRegion(jbyteArray array,
//C     			    jsize start, jsize len, jbyte *buf) {
//C             functions->GetByteArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetCharArrayRegion(jcharArray array,
//C     			    jsize start, jsize len, jchar *buf) {
//C             functions->GetCharArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetShortArrayRegion(jshortArray array,
//C     			     jsize start, jsize len, jshort *buf) {
//C             functions->GetShortArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetIntArrayRegion(jintArray array,
//C     			   jsize start, jsize len, jint *buf) {
//C             functions->GetIntArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetLongArrayRegion(jlongArray array,
//C     			    jsize start, jsize len, jlong *buf) {
//C             functions->GetLongArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetFloatArrayRegion(jfloatArray array,
//C     			     jsize start, jsize len, jfloat *buf) {
//C             functions->GetFloatArrayRegion(this,array,start,len,buf);
//C         }
//C         void GetDoubleArrayRegion(jdoubleArray array,
//C     			      jsize start, jsize len, jdouble *buf) {
//C             functions->GetDoubleArrayRegion(this,array,start,len,buf);
//C         }

//C         void SetBooleanArrayRegion(jbooleanArray array, jsize start, jsize len,
//C     			       const jboolean *buf) {
//C             functions->SetBooleanArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetByteArrayRegion(jbyteArray array, jsize start, jsize len,
//C     			    const jbyte *buf) {
//C             functions->SetByteArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetCharArrayRegion(jcharArray array, jsize start, jsize len,
//C     			    const jchar *buf) {
//C             functions->SetCharArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetShortArrayRegion(jshortArray array, jsize start, jsize len,
//C     			     const jshort *buf) {
//C             functions->SetShortArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetIntArrayRegion(jintArray array, jsize start, jsize len,
//C     			   const jint *buf) {
//C             functions->SetIntArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetLongArrayRegion(jlongArray array, jsize start, jsize len,
//C     			    const jlong *buf) {
//C             functions->SetLongArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetFloatArrayRegion(jfloatArray array, jsize start, jsize len,
//C     			     const jfloat *buf) {
//C             functions->SetFloatArrayRegion(this,array,start,len,buf);
//C         }
//C         void SetDoubleArrayRegion(jdoubleArray array, jsize start, jsize len,
//C     			      const jdouble *buf) {
//C             functions->SetDoubleArrayRegion(this,array,start,len,buf);
//C         }

//C         jint RegisterNatives(jclass clazz, const JNINativeMethod *methods,
//C     			 jint nMethods) {
//C             return functions->RegisterNatives(this,clazz,methods,nMethods);
//C         }
//C         jint UnregisterNatives(jclass clazz) {
//C             return functions->UnregisterNatives(this,clazz);
//C         }

//C         jint MonitorEnter(jobject obj) {
//C             return functions->MonitorEnter(this,obj);
//C         }
//C         jint MonitorExit(jobject obj) {
//C             return functions->MonitorExit(this,obj);
//C         }

//C         jint GetJavaVM(JavaVM **vm) {
//C             return functions->GetJavaVM(this,vm);
//C         }

//C         void GetStringRegion(jstring str, jsize start, jsize len, jchar *buf) {
//C             functions->GetStringRegion(this,str,start,len,buf);
//C         }
//C         void GetStringUTFRegion(jstring str, jsize start, jsize len, char *buf) {
//C             functions->GetStringUTFRegion(this,str,start,len,buf);
//C         }

//C         void * GetPrimitiveArrayCritical(jarray array, jboolean *isCopy) {
//C             return functions->GetPrimitiveArrayCritical(this,array,isCopy);
//C         }
//C         void ReleasePrimitiveArrayCritical(jarray array, void *carray, jint mode) {
//C             functions->ReleasePrimitiveArrayCritical(this,array,carray,mode);
//C         }

//C         const jchar * GetStringCritical(jstring string, jboolean *isCopy) {
//C             return functions->GetStringCritical(this,string,isCopy);
//C         }
//C         void ReleaseStringCritical(jstring string, const jchar *cstring) {
//C             functions->ReleaseStringCritical(this,string,cstring);
//C         }

//C         jweak NewWeakGlobalRef(jobject obj) {
//C             return functions->NewWeakGlobalRef(this,obj);
//C         }
//C         void DeleteWeakGlobalRef(jweak ref) {
//C             functions->DeleteWeakGlobalRef(this,ref);
//C         }

//C         jboolean ExceptionCheck() {
//C     	return functions->ExceptionCheck(this);
//C         }

//C         jobject NewDirectByteBuffer(void* address, jlong capacity) {
//C             return functions->NewDirectByteBuffer(this, address, capacity);
//C         }
//C         void* GetDirectBufferAddress(jobject buf) {
//C             return functions->GetDirectBufferAddress(this, buf);
//C         }
//C         jlong GetDirectBufferCapacity(jobject buf) {
//C             return functions->GetDirectBufferCapacity(this, buf);
//C         }

//C     #endif /* __cplusplus */
//C     };
struct JNIEnv_
{
    JNINativeInterface_ *functions;
}

//C     typedef struct JavaVMOption {
//C         char *optionString;
//C         void *extraInfo;
//C     } JavaVMOption;
struct JavaVMOption
{
    char *optionString;
    void *extraInfo;
}

//C     typedef struct JavaVMInitArgs {
//C         jint version;

//C         jint nOptions;
//C         JavaVMOption *options;
//C         jboolean ignoreUnrecognized;
//C     } JavaVMInitArgs;
struct JavaVMInitArgs
{
    jint versionNumber;
    jint nOptions;
    JavaVMOption *options;
    jboolean ignoreUnrecognized;
}

//C     typedef struct JavaVMAttachArgs {
//C         jint version;

//C         char *name;
//C         jobject group;
//C     } JavaVMAttachArgs;
struct JavaVMAttachArgs
{
    jint versionNumber;
    char *name;
    jobject group;
}

/* These structures will be VM-specific. */

//C     typedef struct JDK1_1InitArgs {
//C         jint version;

//C         char **properties;
//C         jint checkSource;
//C         jint nativeStackSize;
//C         jint javaStackSize;
//C         jint minHeapSize;
//C         jint maxHeapSize;
//C         jint verifyMode;
//C         char *classpath;

//C         jint (JNICALL *vfprintf)(FILE *fp, const char *format, va_list args);
//C         void (JNICALL *exit)(jint code);
//C         void (JNICALL *abort)(void);

//C         jint enableClassGC;
//C         jint enableVerboseGC;
//C         jint disableAsyncGC;
//C         jint verbose;
//C         jboolean debugging;
//C         jint debugPort;
//C     } JDK1_1InitArgs;
struct JDK1_1InitArgs
{
    jint versionNumber;
    char **properties;
    jint checkSource;
    jint nativeStackSize;
    jint javaStackSize;
    jint minHeapSize;
    jint maxHeapSize;
    jint verifyMode;
    char *classpath;
    jint  function(FILE *fp, char *format, va_list args)vfprintf;
    void  function(jint code)exit;
    void  function()abort;
    jint enableClassGC;
    jint enableVerboseGC;
    jint disableAsyncGC;
    jint verbose;
    jboolean debugging;
    jint debugPort;
}

//C     typedef struct JDK1_1AttachArgs {
//C         void * __padding; /* C compilers don't allow empty structures. */
//C     } JDK1_1AttachArgs;
struct JDK1_1AttachArgs
{
    void *__padding;
}

//C     #define JDK1_2
//C     #define JDK1_4

/* End VM-specific. */

//C     struct JNIInvokeInterface_ {
//C         void *reserved0;
//C         void *reserved1;
//C         void *reserved2;

//C         jint (JNICALL *DestroyJavaVM)(JavaVM *vm);

//C         jint (JNICALL *AttachCurrentThread)(JavaVM *vm, void **penv, void *args);

//C         jint (JNICALL *DetachCurrentThread)(JavaVM *vm);

//C         jint (JNICALL *GetEnv)(JavaVM *vm, void **penv, jint version);

//C         jint (JNICALL *AttachCurrentThreadAsDaemon)(JavaVM *vm, void **penv, void *args);
//C     };
struct JNIInvokeInterface_
{
    void *reserved0;
    void *reserved1;
    void *reserved2;
    jint  function(JavaVM *vm)DestroyJavaVM;
    jint  function(JavaVM *vm, void **penv, void *args)AttachCurrentThread;
    jint  function(JavaVM *vm)DetachCurrentThread;
    jint  function(JavaVM *vm, void **penv, jint versionNumber)GetEnv;
    jint  function(JavaVM *vm, void **penv, void *args)AttachCurrentThreadAsDaemon;
}

//C     struct JavaVM_ {
//C         const struct JNIInvokeInterface_ *functions;
//C     #ifdef __cplusplus

//C         jint DestroyJavaVM() {
//C             return functions->DestroyJavaVM(this);
//C         }
//C         jint AttachCurrentThread(void **penv, void *args) {
//C             return functions->AttachCurrentThread(this, penv, args);
//C         }
//C         jint DetachCurrentThread() {
//C             return functions->DetachCurrentThread(this);
//C         }

//C         jint GetEnv(void **penv, jint version) {
//C             return functions->GetEnv(this, penv, version);
//C         }
//C         jint AttachCurrentThreadAsDaemon(void **penv, void *args) {
//C             return functions->AttachCurrentThreadAsDaemon(this, penv, args);
//C         }
//C     #endif
//C     };
struct JavaVM_
{
    JNIInvokeInterface_ *functions;
}

//C     #ifdef _JNI_IMPLEMENTATION_
//C     #define _JNI_IMPORT_OR_EXPORT_ JNIEXPORT
//C     #else
//C     #define _JNI_IMPORT_OR_EXPORT_ JNIIMPORT
//C     #endif
//alias JNIIMPORT _JNI_IMPORT_OR_EXPORT_;
//C     _JNI_IMPORT_OR_EXPORT_ jint JNICALL
//C     JNI_GetDefaultJavaVMInitArgs(void *args);
version (Windows) {
  extern (Windows):
}
jint  JNI_GetDefaultJavaVMInitArgs(void *args);

//C     _JNI_IMPORT_OR_EXPORT_ jint JNICALL
//C     JNI_CreateJavaVM(JavaVM **pvm, void **penv, void *args);
jint  JNI_CreateJavaVM(JavaVM **pvm, void **penv, void *args);

//C     _JNI_IMPORT_OR_EXPORT_ jint JNICALL
//C     JNI_GetCreatedJavaVMs(JavaVM **, jsize, jsize *);
jint  JNI_GetCreatedJavaVMs(JavaVM **, jsize , jsize *);

/* Defined by native libraries. */
//C     JNIEXPORT jint JNICALL
//C     JNI_OnLoad(JavaVM *vm, void *reserved);
jint  JNI_OnLoad(JavaVM *vm, void *reserved);

//C     JNIEXPORT void JNICALL
//C     JNI_OnUnload(JavaVM *vm, void *reserved);
void  JNI_OnUnload(JavaVM *vm, void *reserved);

//C     #define JNI_VERSION_1_1 0x00010001
//C     #define JNI_VERSION_1_2 0x00010002
const JNI_VERSION_1_1 = 0x00010001;
//C     #define JNI_VERSION_1_4 0x00010004
const JNI_VERSION_1_2 = 0x00010002;

const JNI_VERSION_1_4 = 0x00010004;
//C     #ifdef __cplusplus
//C     } /* extern "C" */
//C     #endif /* __cplusplus */

//C     #endif /* !_JAVASOFT_JNI_H_ */
